package main

/*
pbmac-2[10:04:56]~/Desktop/Go>go test *.go
ok  	command-line-arguments	0.006s
pbmac-2[10:05:52]~/Desktop/Go>go test -coverprofile cover.out *.go
ok  	command-line-arguments	0.006s	coverage: 14.0% of statements
pbmac-2[10:06:35]~/Desktop/Go>go tool cover -html=cover.out
*/

import (
  "testing"
  "math"
)

func TestAvgConstant(t *testing.T) {
  v, ok := avg([]int{18, 18, 18})
  if v != 18.0 || ok != true {
    t.Error("Expected 18.0 and true, got ", v, ok)
  }
}

func TestAvg32(t *testing.T) {
  v, ok := avg([]int{32, 30, 30})
  if v != 30.0 || ok != true {
    t.Error("Expected 18.0 and true, got ", v, ok)
  }
}

func TestAvgEmpty(t *testing.T) {
  _, ok := avg([]int{})
  if ok == true {
    t.Error("Expected false, got ", ok)
  }
}

func TestAvgStrano(t *testing.T) {
  v, ok := avg([]int{18, 30, 22})  // Media: 23.333333
  if math.Abs(v-23.33) > 0.1 || ok != true {
    t.Error("Expected 18.0 and true, got ", v, ok)
  }
}
